﻿Imports System.Drawing.Drawing2D

Public Class Form1
    'M２０までの表示
    Const COMPANY_NAME As String = "山本ねじ工販株式会社"
    Const ARTICLE_NAME As String = "皿ボルト"
    Const FILE1_NAME As String = "Dish bolt1.csv"
    Const FILE2_NAME As String = "Dish bolt2.csv"
    Const FILE3_NAME As String = "material.csv"
    Const BMP_NAME As String = "zumenn.bmp"
    Const PIX_SIZE As Decimal = 4  '実線のピクセルサイズの基本値
    Const SMF_NAME As String = "SMFM"
    Const FH_NAME As String = "FHM"
    
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.KeyPreview = True
    End Sub
    Private Sub Form1_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles MyBase.KeyPress
        If e.KeyChar = Chr(Keys.Enter) Then
            Me.SelectNextControl(Me.ActiveControl, True, True, True, True)
            e.Handled = True
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Try
            Dim ysnt As Decimal = 130  'Ｙの基準点
            Dim pixs As Decimal    'TextBox8に入力された文字   実線のピクセルサイズ（基本は　４）
            Dim txt1 As String     'TextBox1に入力された文字
            Dim l As Decimal       'TextBox2に入力された文字   全長
            Dim xsnt1 As Decimal   'TextBox6に入力された文字   端面側基準点
            Dim xsnt2 As Decimal   'TextBox7に入力された文字　　ねじ側基準点

            Dim tyb As Decimal     '呼び径文字の位置変更の変数　　ラインロケーション兼用

            txt1 = TextBox1.Text
            l = TextBox2.Text
            xsnt1 = TextBox6.Text
            xsnt2 = TextBox7.Text
            pixs = TextBox8.Text
            tyb = TextBox9.Text

            Dim bitmapsize As Integer = 4
            Dim selpix As Decimal = 4  '枠線のピクセルサイズ　（基本は　４）

            Dim g As Graphics
            PictureBox1.Image = New Bitmap(210 * bitmapsize, 297 * bitmapsize)
            g = Graphics.FromImage(PictureBox1.Image)

            '線の太さと色の設定
            Dim pb1 As New Pen(Color.Black, 1)  '線の太さ
            Dim pb2 As New Pen(Color.Black, 2)  '線の太さ
            Dim pb3 As New Pen(Color.Black, 3)  '線の太さ　

            '文字サイズの数値
            Dim txtm As Decimal = 20 '大文字サイズ
            Dim txts As Decimal = 16 '中文字サイズ
            Dim fxize As Decimal = 12 '数値の大きさ 寸法数値
            Dim comsiz As Decimal = 9 '公差数値の大きさ


            'ココからはセルの設定
            '外枠の設定
            g.DrawRectangle(pb3, 12 * selpix, 12 * selpix, 186 * selpix, 273 * selpix)
            'ココから水平線の指定
            '上段水平線
            g.DrawLine(pb3, 12 * selpix, 243 * selpix, 198 * selpix, 243 * selpix)
            '２段目水平線
            g.DrawLine(pb2, 68 * selpix, 254 * selpix, 198 * selpix, 254 * selpix)
            '3段目水平線
            g.DrawLine(pb2, 68 * selpix, 265 * selpix, 198 * selpix, 265 * selpix)
            '４段目の水平線
            g.DrawLine(pb2, 68 * selpix, 275 * selpix, 198 * selpix, 275 * selpix)
            '寸法区分の水平線
            g.DrawLine(pb2, 12 * selpix, 249 * selpix, 68 * selpix, 249 * selpix)
            g.DrawLine(pb2, 12 * selpix, 255 * selpix, 68 * selpix, 255 * selpix)
            g.DrawLine(pb2, 12 * selpix, 261 * selpix, 68 * selpix, 261 * selpix)
            g.DrawLine(pb2, 12 * selpix, 267 * selpix, 68 * selpix, 267 * selpix)
            g.DrawLine(pb2, 12 * selpix, 273 * selpix, 68 * selpix, 273 * selpix)
            g.DrawLine(pb2, 12 * selpix, 279 * selpix, 68 * selpix, 279 * selpix)

            'ここから垂直線の指定
            '右から１列目
            g.DrawLine(pb2, 162 * selpix, 243 * selpix, 162 * selpix, 265 * selpix)
            '右から２列目
            g.DrawLine(pb2, 126 * selpix, 243 * selpix, 126 * selpix, 285 * selpix)
            '右から３列目
            g.DrawLine(pb3, 68 * selpix, 243 * selpix, 68 * selpix, 285 * selpix)
            '許容差　垂直線
            g.DrawLine(pb2, 54 * selpix, 243 * selpix, 54 * selpix, 285 * selpix)

            '加工マークの表示
            Dim b As New Font("ＭＳ 明朝", 50, FontStyle.Regular)
            g.DrawString("▽", b, Brushes.Black, 160 * selpix, 25 * selpix)

            '文字のフォント指定。
            Dim c As New Font("ＭＳ Ｐゴシック", txts, FontStyle.Bold)   '中文字サイズ
            Dim d As New Font("ＭＳ Ｐゴシック", txtm, FontStyle.Bold)   '大文字サイズ
            Dim f As New Font("ＭＳ Ｐゴシック", fxize, FontStyle.Bold)  '数値の大きさ 寸法数値のインスタンス
            Dim h As New Font("ＭＳ Ｐゴシック", comsiz, FontStyle.Bold) '公差数値の大きさのインスタンス
            '図面枠内の文字表示
            g.DrawString("寸法区分", f, Brushes.Black, 23 * selpix, 244 * selpix)
            g.DrawString("   　0.5以上　  　 6以下", f, Brushes.Black, 11.5 * selpix, 250 * selpix)
            g.DrawString("     6を超え    　30以下", f, Brushes.Black, 11.5 * selpix, 256 * selpix)
            g.DrawString("   30を超え     120以下", f, Brushes.Black, 11.5 * selpix, 262 * selpix)
            g.DrawString(" 120を超え　   315以下", f, Brushes.Black, 11.5 * selpix, 268 * selpix)
            g.DrawString(" 315を超え　 1000以下", f, Brushes.Black, 11.5 * selpix, 274 * selpix)
            g.DrawString("1000を超え   2000以下", f, Brushes.Black, 11.5 * selpix, 280 * selpix)
            '許容さの表示
            g.DrawString("許容差", f, Brushes.Black, 54 * selpix, 244 * selpix)
            g.DrawString("±0.1", f, Brushes.Black, 55 * selpix, 250 * selpix)
            g.DrawString("±0.2", f, Brushes.Black, 55 * selpix, 256 * selpix)
            g.DrawString("±0.3", f, Brushes.Black, 55 * selpix, 262 * selpix)
            g.DrawString("±0.5", f, Brushes.Black, 55 * selpix, 268 * selpix)
            g.DrawString("±0.8", f, Brushes.Black, 55 * selpix, 274 * selpix)
            g.DrawString("±1.2", f, Brushes.Black, 55 * selpix, 280 * selpix)

            '大枠内の文字の表示
            g.DrawString("材質", f, Brushes.Black, 69 * selpix, 244 * selpix)
            g.DrawString("熱処理　硬度", f, Brushes.Black, 69 * selpix, 255 * selpix)
            g.DrawString("表面処理", f, Brushes.Black, 69 * selpix, 265 * selpix)
            g.DrawString("図法", f, Brushes.Black, 127 * selpix, 244 * selpix)
            g.DrawString("承認", f, Brushes.Black, 127 * selpix, 255 * selpix)
            g.DrawString("図番", f, Brushes.Black, 127 * selpix, 265 * selpix)
            g.DrawString("品名", f, Brushes.Black, 127 * selpix, 275 * selpix)
            g.DrawString("尺度", f, Brushes.Black, 162 * selpix, 244 * selpix)
            g.DrawString("製図", f, Brushes.Black, 162 * selpix, 255 * selpix)
            g.DrawString(COMPANY_NAME, c, Brushes.Black, 69 * selpix, 278 * selpix)
            g.DrawString("三角法", d, Brushes.Black, 135 * selpix, 246 * selpix)
            g.DrawString(ARTICLE_NAME, d, Brushes.Black, 135 * selpix, 277 * selpix)
            '材質表示　メソッドの戻り値を使用
            Dim matei = mtrl()
            Dim disp = mtrl()
            g.DrawString(matei.Item1, d, Brushes.Black, 80 * selpix, 246 * selpix)
            '熱処理　高度　メソッドの戻り値を使用
            g.DrawString(disp.Item2, f, Brushes.Black, 71 * selpix, 260 * selpix)
            '尺度
            Dim leng As Decimal
            leng = pixs / PIX_SIZE
            g.DrawString(leng & "/" & "1", d, Brushes.Black, 175 * selpix, 246 * selpix)
            '図番の表示  メソッドの戻り値を使用
            Dim ln As String  'TextBox2に入力された文字 全長が100未満か100以上で0を付ける
            Dim num = angmsd()
            Dim txt3 As String  '材料コード TextBox3
            Dim txt3u As String     'TextBox3に入力された文字の大文字化
            txt3 = TextBox3.Text
            txt3u = UCase(txt3)
            If 100 > l Then
                ln = "0" & l
            ElseIf l >= 100 Then
                ln = l
            End If
            If 8 >= num.Item3 Then
                g.DrawString(SMF_NAME & "0" & txt1 & "X" & ln + txt3u, d, Brushes.Black, 136 * selpix, 267 * selpix)
            ElseIf 8 < num.Item3 Then
                g.DrawString(FH_NAME & txt1 & "X" & ln + txt3u, d, Brushes.Black, 136 * selpix, 267 * selpix)
            End If

            'Dish bolt.csvファイルの読み込み
            Dim yobi As String   '(0)呼び径　 
            Dim pitti As String  '(1)ピッチ
            Dim ds As String     '(2)胴部径
            Dim ds0 As String    '(3)胴部径　０公差
            Dim dsmns As String  '(4)胴部径　マイナス公差
            Dim dk As String     '(5)頭部径      
            Dim dk0 As String    '(6)頭部径　０公差
            Dim dkmmns As String '(7)頭部径　マイナス公差
            Dim k As String      '(8)皿部厚み
            Dim cs As String      '(9)皿部平面量
            Dim thi As String    '(10)皿部角度
            Dim thiprs As String '(11)皿部角度　プラス公差
            Dim thi0 As String   '(12)皿部角度　０公差
            Dim n As String      '(13)すり割り幅  
            Dim nprs As String   '(14)すり割り幅　プラス公差
            Dim n0 As String     '(15)すり割り幅　０公差
            Dim t As String      '(16)すり割り長さ
            Dim tpsms As String  '(17))すり割り長さ　公差
            Dim item() As String  '配列の各項目
            Dim line As String    'ＣＳＶの１行
            Dim dsl As String     '胴部の長さ


            'ＣＳＶファイルの読み込み
            Dim reader As New IO.StreamReader(Application.StartupPath & "\" & FILE1_NAME, System.Text.Encoding.GetEncoding("shift-jis"))
            line = reader.ReadLine

            Do Until IsNothing(line)
                item = line.Split(",")
                yobi = item(0)
                pitti = item(1)
                ds = item(2)
                ds0 = item(3)
                dsmns = item(4)
                dk = item(5)
                dk0 = item(6)
                dkmmns = item(7)
                k = item(8)
                cs = item(9)
                thi = item(10)
                thiprs = item(11)
                thi0 = item(12)
                n = item(13)
                nprs = item(14)
                n0 = item(15)
                t = item(16)
                tpsms = item(17)

                yobi = yobi.Replace("""", "")
                pitti = pitti.Replace("""", "")
                ds = ds.Replace("""", "")
                ds0 = ds0.Replace("""", "")
                dsmns = dsmns.Replace("""", "")
                dk = dk.Replace("""", "")
                dk0 = dk0.Replace("""", "")
                dkmmns = dkmmns.Replace("""", "")
                k = k.Replace("""", "")
                cs = cs.Replace("""", "")
                thi = thi.Replace("""", "")
                thiprs = thiprs.Replace("""", "")
                thi0 = thi0.Replace("""", "")
                n = n.Replace("""", "")
                nprs = nprs.Replace("""", "")
                n0 = n0.Replace("""", "")
                t = t.Replace("""", "")
                tpsms = tpsms.Replace("""", "")

                If "M" & txt1 = yobi Then
                    'StringをDecimalに変換してpixsをかける
                    Dim xsnt1p As Decimal = xsnt1 * pixs
                    Dim xsnt2p As Decimal = xsnt2 * pixs
                    Dim ysntp As Decimal = ysnt * 4
                    Dim sizp As Decimal = 4    '寸法線と寸法文字のピクセルサイズ（基本は4）
                    Dim dkp As Decimal = CDec(dk) * pixs
                    Dim lp As Decimal = l * pixs
                    Dim np As Decimal = CDec(n) * pixs
                    Dim tp As Decimal = CDec(t) * pixs
                    Dim csp As Decimal = CDec(cs) * pixs
                    Dim dsp As Decimal = CDec(ds) * pixs
                    Dim pittip As Decimal = CDec(pitti) * pixs
                    Dim txt1p As Decimal = CDec(txt1) * pixs
                    Dim tybp As Decimal = CDec(tyb) * pixs

                    'ここから端面図の作成
                    '角度を求めるメソッドから戻り値を取得する
                    Dim ang = angmsd()
                    Dim dk1p As Decimal
                    dk1p = dkp / 2 * (Math.Cos(ang.Item1 / 180 * Math.PI))

                    'すり割り　水平線
                    g.DrawLine(pb2, xsnt1p - dk1p, ysntp - np / 2, xsnt1p + dk1p, ysntp - np / 2)
                    g.DrawLine(pb2, xsnt1p - dk1p, ysntp + np / 2, xsnt1p + dk1p, ysntp + np / 2)

                    '端面図　半円の作成
                    g.DrawArc(pb2, xsnt1p - dkp / 2, ysntp - dkp / 2, dkp, dkp, 180 + ang.Item1, 180 - ang.Item1 * 2)
                    g.DrawArc(pb2, xsnt1p - dkp / 2, ysntp - dkp / 2, dkp, dkp, ang.Item1, 180 - ang.Item1 * 2)

                    'すり割りきり欠き　垂直線
                    g.DrawArc(pb2, xsnt1p - (dkp / 2) + (tp / 2), ysntp - (dkp / 2) + (tp / 2), dkp - tp, dkp - tp, 360 - ang.Item2, ang.Item2 * 2)
                    g.DrawArc(pb2, xsnt1p - (dkp / 2) + (tp / 2), ysntp - (dkp / 2) + (tp / 2), dkp - tp, dkp - tp, 180 - ang.Item2, ang.Item2 * 2)

                    'ここからねじ部の作成
                    'ねじ端面図 垂直線
                    g.DrawLine(pb2, xsnt2p, ysntp - dkp / 2, xsnt2p, ysntp - np / 2)
                    g.DrawLine(pb2, xsnt2p, ysntp + dkp / 2, xsnt2p, ysntp + np / 2)
                    g.DrawLine(pb2, xsnt2p + tp, ysntp - np / 2, xsnt2p + tp, ysntp + np / 2)
                    g.DrawLine(pb1, xsnt2p + csp, ysntp - dkp / 2, xsnt2p + csp, ysntp - np / 2)
                    g.DrawLine(pb1, xsnt2p + csp, ysntp + dkp / 2, xsnt2p + csp, ysntp + np / 2)

                    'ねじ端面図　水平線
                    g.DrawLine(pb2, xsnt2p, ysntp - np / 2, xsnt2p + tp, ysntp - np / 2)
                    g.DrawLine(pb2, xsnt2p, ysntp + np / 2, xsnt2p + tp, ysntp + np / 2)
                    g.DrawLine(pb2, xsnt2p, ysntp - dkp / 2, xsnt2p + csp, ysntp - dkp / 2)
                    g.DrawLine(pb2, xsnt2p, ysntp + dkp / 2, xsnt2p + csp, ysntp + dkp / 2)

                    '45°斜線  ねじ谷径まで表示
                    Dim kx As Decimal     '水平方向の寸法
                    Dim kxp As Decimal = kx * pixs
                    kxp = (dkp / 2 - dsp / 2) * (Math.Tan(thi / 2 / 180 * Math.PI))
                    g.DrawLine(pb2, xsnt2p + csp, ysntp - dkp / 2, xsnt2p + csp + kxp, ysntp - dsp / 2)
                    g.DrawLine(pb2, xsnt2p + csp, ysntp + dkp / 2, xsnt2p + csp + kxp, ysntp + dsp / 2)

                    'ねじのライン　メソッドの返り値を使用する
                    Dim s = nejiil()  '有効ねじ長さ
                    Dim sp As Decimal = CDec(s.Item1) * pixs '有効ねじ長さのピクセル化

                    'ねじ外径線　　水平線+胴部のライン　水平線
                    dsl = l - k - s.Item1 - 2 * pitti       '胴部の長さの定義+ネジ外径ライン　水平線
                    Dim dslp As Decimal = CDec(dsl) * pixs
                    If s.Item1 + pitti * 2 >= l - k Then  '全ねじ条件
                        dslp = 0
                    End If

                    '全長が100を超えたときのdslpの処理
                    If l >= 100 Then
                        dslp = 65 * pixs - sp - pittip * 2
                    End If

                    'ねじ外径線　　水平線+胴部のライン　水平線
                    g.DrawLine(pb2, xsnt2p + csp + kxp, ysntp - dsp / 2, xsnt2p + csp + kxp + sp + dslp, ysntp - dsp / 2)
                    g.DrawLine(pb2, xsnt2p + csp + kxp, ysntp + dsp / 2, xsnt2p + csp + kxp + sp + dslp, ysntp + dsp / 2)

                    'ねじ谷径線　水平線
                    g.DrawLine(pb2, xsnt2p + csp + kxp + pittip + dslp, ysntp - dsp / 2 + pittip, xsnt2p + csp + kxp + pittip + sp + dslp, ysntp - dsp / 2 + pittip)
                    g.DrawLine(pb2, xsnt2p + csp + kxp + pittip + dslp, ysntp + dsp / 2 - pittip, xsnt2p + csp + kxp + pittip + sp + dslp, ysntp + dsp / 2 - pittip)

                    '不完全ネジ部ライン　斜線　切り上げ部と先端面取り部
                    g.DrawLine(pb2, xsnt2p + csp + kxp + dslp, ysntp - dsp / 2, xsnt2p + csp + kxp + pittip + dslp, ysntp - dsp / 2 + pittip)
                    g.DrawLine(pb2, xsnt2p + csp + kxp + dslp, ysntp + dsp / 2, xsnt2p + csp + kxp + pittip + dslp, ysntp + dsp / 2 - pittip)
                    g.DrawLine(pb2, xsnt2p + csp + kxp + sp + dslp, ysntp - dsp / 2, xsnt2p + csp + kxp + pittip + sp + dslp, ysntp - dsp / 2 + pittip)
                    g.DrawLine(pb2, xsnt2p + csp + kxp + sp + dslp, ysntp + dsp / 2, xsnt2p + csp + kxp + pittip + sp + dslp, ysntp + dsp / 2 - pittip)

                    'ネジ部垂直線
                    g.DrawLine(pb2, xsnt2p + csp + kxp, ysntp - dsp / 2, xsnt2p + csp + kxp, ysntp + dsp / 2)
                    g.DrawLine(pb2, xsnt2p + csp + kxp + pittip + dslp, ysntp - dsp / 2 + pittip, xsnt2p + csp + kxp + pittip + dslp, ysntp + dsp / 2 - pittip)
                    'ネジ先端部　垂直線
                    g.DrawLine(pb2, xsnt2p + csp + kxp + sp + dslp, ysntp - dsp / 2, xsnt2p + csp + kxp + sp + dslp, ysntp + dsp / 2)
                    g.DrawLine(pb2, xsnt2p + csp + kxp + pittip + sp + dslp, ysntp - dsp / 2 + pittip, xsnt2p + csp + kxp + pittip + sp + dslp, ysntp + dsp / 2 - pittip)

                    '全長寸法ｌが100を超えた場合の胴部の斜線
                    If l >= 100 Then
                        g.DrawLine(pb2, xsnt2p + csp + kxp + dslp / 2, ysntp - dsp / 2, xsnt2p + csp + kxp + dslp / 2 - pittip, ysntp + dsp / 2)
                        g.DrawLine(pb2, xsnt2p + csp + kxp + dslp / 2 - pittip, ysntp - dsp / 2, xsnt2p + csp + kxp + dslp / 2 - pittip * 2, ysntp + dsp / 2)
                    End If


                    'ここから寸法線
                    '端面側
                    '(5)頭部径　垂直線
                    g.DrawLine(pb2, xsnt1p - dkp / 2, ysntp, xsnt1p - dkp / 2, ysntp - dkp / 2 - 30 * sizp)
                    g.DrawLine(pb2, xsnt1p + dkp / 2, ysntp, xsnt1p + dkp / 2, ysntp - dkp / 2 - 30 * sizp)

                    'ねじ側 　端面線　垂直線
                    g.DrawLine(pb1, xsnt2p, ysntp - dkp / 2, xsnt2p, ysntp - dkp / 2 - 30 * sizp)
                    'ねじ側　垂直線
                    g.DrawLine(pb1, xsnt2p + csp, ysntp - dkp / 2, xsnt2p + csp, ysntp - dkp / 2 - 20 * sizp)
                    'ねじ先端　垂直線
                    g.DrawLine(pb2, xsnt2p + csp + kxp + sp + dslp + pittip, ysntp - dsp / 2 + pittip, xsnt2p + csp + kxp + sp + dslp + pittip, ysntp - dkp / 2 - 30 * sizp)

                    'すり割り寸法　垂直線
                    g.DrawLine(pb2, xsnt2p, ysntp + dkp / 2, xsnt2p, ysntp + dkp / 2 + 30 * sizp)
                    g.DrawLine(pb2, xsnt2p + tp, ysntp + np / 2, xsnt2p + tp, ysntp + dkp / 2 + 30 * sizp)

                    'すり割り寸法 水平線
                    g.DrawLine(pb2, xsnt2p, ysntp + dkp / 2 + 28 * sizp, xsnt2p + tp, ysntp + dkp / 2 + 28 * sizp)

                    'ｃ寸法線　水平線
                    g.DrawLine(pb1, xsnt2p, ysntp - dkp / 2 - 18 * sizp, xsnt2p + csp, ysntp - dkp / 2 - 18 * sizp)

                    '溝幅ｎの寸法線　水平線
                    g.DrawLine(pb2, xsnt2p, ysntp - np / 2, xsnt2p - 10 * sizp, ysntp - np / 2)
                    g.DrawLine(pb2, xsnt2p, ysntp + np / 2, xsnt2p - 10 * sizp, ysntp + np / 2)
                    '溝幅ｎの寸法線  垂直線
                    g.DrawLine(pb2, xsnt2p - 8 * sizp, ysntp - np / 2, xsnt2p - 8 * sizp, ysntp + np / 2)

                    '角度表示のための水平線
                    g.DrawLine(pb2, xsnt2p, ysntp - dkp / 2, xsnt2p - 20 * sizp, ysntp - dkp / 2)

                    '角度表示の斜線
                    Dim tln As Decimal
                    tln = (25 * sizp) * (Math.Tan(thi / 2 / 180 * Math.PI))
                    g.DrawLine(pb2, xsnt2p + csp, ysntp - dkp / 2, xsnt2p - 25 * sizp + csp, (ysntp - dkp / 2) - tln)

                    '胴部dslが０(dslがpitti以上あるときのみ表示する)以上の時の胴部径の寸法線   垂直線
                    If CDec(dsl) > CDec(pitti) Then
                        g.DrawLine(pb2, xsnt2p + csp + kxp + dslp / 2, ysntp + dsp / 2, xsnt2p + csp + kxp + dslp / 2, ysntp + dsp / 2 + 23 * sizp)
                    End If


                    'ココから矢印付きの寸法線
                    '←→付きの場合
                    pb2.CustomStartCap = New AdjustableArrowCap(4, 8)
                    pb2.CustomEndCap = New AdjustableArrowCap(4, 8)
                    '全長寸法  水平線
                    g.DrawLine(pb2, xsnt2p, ysntp - dkp / 2 - 28 * sizp, xsnt2p + csp + kxp + pittip + sp + dslp, ysntp - dkp / 2 - 28 * sizp)

                    '外径寸法ｄｋ 水平線
                    g.DrawLine(pb2, xsnt1p - dkp / 2, ysntp - dkp / 2 - 28 * sizp, xsnt1p + dkp / 2, ysntp - dkp / 2 - 28 * sizp)

                    '角度のスイーブライン
                    pb2.CustomStartCap = New AdjustableArrowCap(3, 5)
                    pb2.CustomEndCap = New AdjustableArrowCap(3, 5)
                    g.DrawArc(pb2, xsnt2p - 10 * sizp, ysntp - dkp / 2 - 10 * sizp, 20 * sizp, 20 * sizp, 180, CDec(thi) / 2)

                    '胴部dslが０(dslがpitti以上あるときのみ表示する)以上の時の胴部径の寸法線   垂直線
                    pb2.CustomStartCap = New AdjustableArrowCap(3, 3)

                    pb2.CustomEndCap = New AdjustableArrowCap(3, 3)
                    If CDec(dsl) > CDec(pitti) Then
                        g.DrawLine(pb2, xsnt2p + csp + kxp + dslp / 2, ysntp - dsp / 2, xsnt2p + csp + kxp + dslp / 2, ysntp + dsp / 2)
                    End If

                    '←付きの場合
                    '角度のスイーブライン
                    Dim thia As Decimal  '角度thi/2の対角を求める変数
                    thia = 180 - 90 - CDec(thi) / 2
                    Dim xsr As Decimal
                    Dim xsrp As Decimal = xsr * pixs  'xの中心線をもとめる変数
                    xsrp = (dkp / 2) * (Math.Tan(thia / 180 * Math.PI))
                    pb2.CustomEndCap = New AdjustableArrowCap(4, 8)
                    pb2.StartCap = LineCap.Flat
                    g.DrawArc(pb2, xsnt2p - 30 * sizp - dkp / 2 + csp + xsrp, ysntp - dkp / 2 - 30 * sizp, 60 * sizp + dkp, 60 * sizp + dkp, 135, (CDec(thi) / 2) + 45)

                    'cの寸法線　水平線
                    g.DrawLine(pb2, xsnt2p - 10 * sizp, ysntp - dkp / 2 - 18 * sizp, xsnt2p, ysntp - dkp / 2 - 18 * sizp)
                    g.DrawLine(pb2, xsnt2p + csp + 6 * sizp, ysntp - dkp / 2 - 18 * sizp, xsnt2p + csp, ysntp - dkp / 2 - 18 * sizp)

                    'すり割り深さt  水平線
                    g.DrawLine(pb2, xsnt2p - 8 * sizp, ysntp + dkp / 2 + 28 * sizp, xsnt2p, ysntp + dkp / 2 + 28 * sizp)
                    g.DrawLine(pb2, xsnt2p + tp + 10 * sizp, ysntp + dkp / 2 + 28 * sizp, xsnt2p + tp, ysntp + dkp / 2 + 28 * sizp)

                    '呼び径表示線　　　斜線
                    g.DrawLine(pb2, xsnt2p + csp + kxp + pittip + sp + dslp + tybp, ysntp + dsp / 2 + 18 * sizp, xsnt2p + csp + kxp + pittip + sp / 2 + dslp, ysntp + dsp / 2)

                    'スリ割り幅寸法線　垂直線
                    pb2.CustomEndCap = New AdjustableArrowCap(3, 6)
                    g.DrawLine(pb2, xsnt2p - 8 * sizp, ysntp - np / 2 - 3 * sizp - pittip, xsnt2p - 8 * sizp, ysntp - np / 2)
                    g.DrawLine(pb2, xsnt2p - 8 * sizp, ysntp + np / 2 + 3 * sizp + pittip, xsnt2p - 8 * sizp, ysntp + np / 2)

                    '呼び径表示線　　水平線　
                    pb2.EndCap = LineCap.Flat
                    g.DrawLine(pb2, xsnt2p + csp + kxp + pittip + sp + dslp + tybp, ysntp + dsp / 2 + 18 * sizp, xsnt2p + csp + kxp + pittip + sp + dslp + tybp + 10 * sizp, ysntp + dsp / 2 + 18 * sizp)

                    '溝幅文字のアンダーライン
                    g.DrawLine(pb2, xsnt2p - 8 * sizp, ysntp + np / 2 + 3 * sizp + pittip, xsnt2p - 18 * sizp, ysntp + np / 2 + 3 * sizp + pittip)

                    'ここから文字の表示
                    '外径dk
                    g.DrawString("Φ" & dk, c, Brushes.Black, xsnt1p - 11 * sizp, ysntp - dkp / 2 - 34 * sizp)
                    '外径dk 公差
                    g.DrawString(dk0, h, Brushes.Black, xsnt1p + 4 * sizp, ysntp - dkp / 2 - 35 * sizp)
                    g.DrawString(dkmmns, h, Brushes.Black, xsnt1p + 2 * sizp, ysntp - dkp / 2 - 32 * sizp)

                    '全長 lの表示
                    '全長公差の表示
                    'メソッドの戻り値を使用する
                    Dim l0 = nejiil()     '(4)　ｌの0公差
                    Dim lms = nejiil()   '(5)　ｌの-公差
                    If dslp > 0 Then
                        g.DrawString(l, c, Brushes.Black, xsnt2p + csp / 2 + kxp / 2 + sp / 2 + dslp / 2 - 4 * sizp, ysntp - dkp / 2 - 34 * sizp)
                        g.DrawString(l0.Item2, h, Brushes.Black, xsnt2p + csp / 2 + kxp / 2 + sp / 2 + dslp / 2 + 5 * sizp, ysntp - dkp / 2 - 35 * sizp)
                        g.DrawString(lms.Item3, h, Brushes.Black, xsnt2p + csp / 2 + kxp / 2 + sp / 2 + dslp / 2 + 3 * sizp, ysntp - dkp / 2 - 32 * sizp)
                    ElseIf dslp = 0 Then
                        g.DrawString(l, c, Brushes.Black, xsnt2p + csp / 2 + kxp / 2 + sp / 2 - 4 * sizp, ysntp - dkp / 2 - 34 * sizp)
                        g.DrawString(l0.Item2, h, Brushes.Black, xsnt2p + csp / 2 + kxp / 2 + sp / 2 + 5 * sizp, ysntp - dkp / 2 - 35 * sizp)
                        g.DrawString(lms.Item3, h, Brushes.Black, xsnt2p + csp / 2 + kxp / 2 + sp / 2 + 3 * sizp, ysntp - dkp / 2 - 32 * sizp)

                    End If

                    'ｃの表示
                    g.DrawString(cs, c, Brushes.Black, xsnt2p - 11 * sizp, ysntp - dkp / 2 - 24 * sizp)

                    'nの表示
                    g.DrawString(n, c, Brushes.Black, xsnt2p - 27 * sizp, ysntp + np / 2 - 3 * sizp + pittip)

                    'nの公差
                    g.DrawString(nprs, h, Brushes.Black, xsnt2p - 20 * sizp, ysntp + np / 2 - 4 * sizp + pittip)
                    g.DrawString(n0, h, Brushes.Black, xsnt2p - 17 * sizp, ysntp + np / 2 - 1 * sizp + pittip)

                    'thi/2の表示
                    g.DrawString(thi / 2 + 0.5 & "°", c, Brushes.Black, xsnt2p - 22 * sizp, ysntp - dkp / 2 - 8 * sizp)

                    'thi 角度の表示
                    g.DrawString(thi & "°", c, Brushes.Black, xsnt2p - 45 * sizp, ysntp - 3 * sizp)

                    'thi 角度の公差表示
                    g.DrawString(thiprs, h, Brushes.Black, xsnt2p - 37 * sizp, ysntp - 4 * sizp)
                    g.DrawString(thi0, h, Brushes.Black, xsnt2p - 34 * sizp, ysntp - 1 * sizp)

                    '溝長さの表示
                    g.DrawString(t, c, Brushes.Black, xsnt2p + tp + 4 * sizp, ysntp + dkp / 2 + 22 * sizp)

                    '溝長さの公差表示
                    g.DrawString(tpsms, h, Brushes.Black, xsnt2p + tp + 12 * sizp, ysntp + dkp / 2 + 23 * sizp)

                    '呼び径の表示
                    g.DrawString(yobi, c, Brushes.Black, xsnt2p + csp + kxp + pittip + sp + dslp + tybp, ysntp + dsp / 2 + 12 * sizp)

                    '胴部dslが０(dslがpitti以上あるときのみ表示する)以上の時の寸法表示 270度回転表示
                    'dsの表示
                    If CDec(dsl) > CDec(pitti) Then
                        Dim ap As Decimal  'dsの文字数によって公差表示位置を変更する変数
                        Dim leds As Integer
                        leds = ds.Length
                        If leds = 1 Then
                            ap = 0
                        ElseIf leds = 2 Then
                            ap = 3 * sizp
                        End If
                        '座標(x,y)に描画するため、ワールド変換を平行移動
                        g.TranslateTransform(xsnt2p + csp + kxp + dslp / 2 + 2 * sizp, ysntp + dsp / 2 + 24 * sizp)
                        'ワールド変換行列を度回転する
                        g.RotateTransform(270)
                        '文字列を(0, 0)に描画
                        g.DrawString("Φ" & ds, c, Brushes.Black, 0, 0)
                        '胴部dslのマイナス公差
                        g.DrawString(dsmns, h, Brushes.Black, 9 * sizp + ap, 2 * sizp)
                        '胴部dslの0公差
                        g.DrawString(ds0, h, Brushes.Black, 11 * sizp + ap, -1 * sizp)
                    End If


                End If
                line = reader.ReadLine
            Loop
            reader.Close()

            g.Dispose()

            savepic()
            openpic()
        Catch ex As Exception

            MsgBox(ex.Message)

        End Try

    End Sub
    'すり割り部きり欠きのための角度メソッド  端面図の作成用
    '図番表示のためのメソッド兼用
    Private Function angmsd() As Tuple(Of Decimal, Decimal, Decimal)
        Dim reader As New IO.StreamReader(Application.StartupPath & "\" & FILE1_NAME, System.Text.Encoding.GetEncoding("shift-jis"))
        Dim ang1 As Decimal
        Dim ang2 As Decimal
        Dim ang3 As Decimal  '(2)胴部径
        Dim yobi As String   '(0)呼び径
        Dim ds As String     '(2)胴部径
        Dim dk As String     '(5)頭部径       
        Dim n As String      '(13)すり割り幅
        Dim t As String      '(16)すり割り長さ
        Dim item() As String  '配列の各項目
        Dim line As String    'ＣＳＶの１行
        Dim txt1 As String     'TextBox1に入力された文字
        txt1 = TextBox1.Text

        line = reader.ReadLine
        Do Until IsNothing(line)
            item = line.Split(",")
            yobi = item(0)
            ds = item(2)
            dk = item(5)
            n = item(13)
            t = item(16)

            yobi = yobi.Replace("""", "")
            ds = ds.Replace("""", "")
            dk = dk.Replace("""", "")
            n = n.Replace("""", "")
            t = t.Replace("""", "")
            If "M" & txt1 = yobi Then
                ang1 = (Math.Asin((n / 2) / (dk / 2))) * (180 / Math.PI)
                ang2 = (Math.Atan(n / 2) / ((dk / 2) - (t / 2))) * (180 / Math.PI)
                ang3 = ds
            End If
            line = reader.ReadLine
        Loop
        reader.Close()
        Return Tuple.Create(item1:=ang1, item2:=ang2, item3:=ang3)
    End Function
    'ネジ長さのメソッド  
    Private Function nejiil() As Tuple(Of String, String, String)
        Dim reader As New IO.StreamReader(Application.StartupPath & "\" & FILE2_NAME, System.Text.Encoding.GetEncoding("shift-jis"))
        Dim yobi As String   '(0)　呼び径
        Dim s As String      '(1)　ネジ長さ     
        Dim ll As String     '(2)　ｌの下限値
        Dim lh As String     '(3)　ｌの上限値　
        Dim l0 As String     '(4)　ｌの0公差
        Dim lms As String   '(5)　ｌの-公差
        Dim item() As String
        Dim line As String
        Dim ans1 As String   'ネジ長さ
        Dim ans2 As String   'ｌの0公差
        Dim ans3 As String   'ｌの0公差

        Dim txt1 As String     'TextBox1に入力された文字 全長
        Dim l As Decimal       'TextBox2に入力された文字   全長
        txt1 = TextBox1.Text
        l = TextBox2.Text
        line = reader.ReadLine

        Do Until IsNothing(line)
            item = line.Split(",")
            yobi = item(0)
            s = item(1)
            ll = item(2)
            lh = item(3)
            l0 = item(4)
            lms = item(5)

            yobi = yobi.Replace("""", "")
            s = s.Replace("""", "")
            ll = ll.Replace("""", "")
            lh = lh.Replace("""", "")
            l0 = l0.Replace("""", "")
            lms = lms.Replace("""", "")

            If yobi = "M" & txt1 Then
                ans1 = s
                If 8 >= CDec(txt1) Then
                    If CDec(lh) >= l AndAlso l > CDec(ll) Then
                        ans2 = l0
                        ans3 = lms
                    End If
                End If
            End If
            line = reader.ReadLine
        Loop

        Return Tuple.Create(item1:=ans1, item2:=ans2, item3:=ans3)

    End Function
    Private Function mtrl() As Tuple(Of String, String)
        Dim reader As New IO.StreamReader(Application.StartupPath & "\" & "material.csv", System.Text.Encoding.GetEncoding("shift-jis"))
        Dim kod As String       '材料コード
        Dim matei As String     '材質
        Dim disp As String      '熱処理　高度
        Dim item() As String   '配列の各項目
        Dim line As String      'ＣＳＶファイルの1行
        Dim mt1 As String       '返す値　材質
        Dim mt2 As String       '返す値　熱処理　高度
        Dim txt3 As String      '材料コード  TextBox3
        Dim txt3u As String     'TextBox3に入力された文字の大文字化
        txt3 = TextBox3.Text
        txt3u = UCase(txt3)

        line = reader.ReadLine

        Do Until IsNothing(line)
            item = line.Split(",")
            kod = item(0)
            matei = item(1)
            disp = item(2)

            kod = kod.Replace("""", "")
            matei = matei.Replace("""", "")
            disp = disp.Replace("""", "")

            If kod = txt3u Then
                mt1 = matei
                mt2 = disp
            End If
            line = reader.ReadLine
        Loop

        Return Tuple.Create(item1:=mt1, item2:=mt2)
    End Function

    '保存のメソッド
    Private Sub savepic()
        If Not (PictureBox1.Image Is Nothing) Then
            PictureBox1.Image.Save(Application.StartupPath & "\" & BMP_NAME)
        End If
    End Sub
    'Process.Startのメソッド
    Private Sub openpic()
        Process.Start(Application.StartupPath & "\" & BMP_NAME)
    End Sub

    Private Sub バージョンToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles バージョンToolStripMenuItem.Click
        MsgBox(Application.ProductName & vbNewLine & "バージョン " & Application.ProductVersion)
    End Sub

    Private Sub 制作ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 制作ToolStripMenuItem.Click
        MsgBox("田中　裕之")
    End Sub
End Class
